using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;


//BASE SCRIPT
namespace Mod
{
    
    public class Mod
    {
        static string TWDtag = " <color=green>[TWD] <color=white>";  
         
        public static void Main()
        {
            CategoryBuilder.Create("The Walking Dead Mod", "We are The Walking Dead", ModAPI.LoadSprite("logo_category.png"));

            ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Negan Smith",
                        DescriptionOverride = "Im Negan",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/NeganSmith/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/NeganSmith/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );   

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Rick Grimes",
                        DescriptionOverride = "I Found Them",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/RickGrimes/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {   
                            var person = Instance.GetComponent<PersonBehaviour>();
                            
                        foreach (var limb in person.Limbs)
						{
							var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
							HumanSprites.person = person;
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/RickGrimes/Skin Layer.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/RickGrimes/Skin Layer1.png"));
						}

                    }   }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = TWDtag + "Rick Grimes Hat",
                        DescriptionOverride = "Sherif Hat",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/RickGrimes/hatThumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/RickGrimes/hat.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 356748f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Skins/RickGrimes/hat.png");
                            Instance.FixColliders();
                        }  
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Michonne Hawthorne",
                        DescriptionOverride = "Hey. I know you're here. I'm still here, too. Maybe you already knew that. But... It hasn't gotten any easier. Sun keeps rising. Days keep passing. World keeps spinning. Time... It just keeps moving forward. Weeks, months, even years go by while you try to make sense of it all. Try to find where you belong. Try to look ahead to a better future. But the truth is... The path ahead has only grown darker. It's harder to see. You can feel... So lost... So alone... So desperate for something, anything that might show you the way. But even now, after all this time, surrounded by darkness there are still flashes of light... Tiny beacons that shine out, calling to us. It's not enough to light the way ahead, but it's enough to keep going. Keep trying. Keep fighting. Keep dreaming. So that's what I do every second of every day... for you, for us. I haven't given up, and I never will.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/MichonneHawthorne/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/MichonneHawthorne/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail3 = new GameObject("Hair Michonne");
                            detail3.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail3.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail3.transform.localEulerAngles = Vector3.zero;
                            detail3.transform.localScale = Vector2.one;

                            SpriteRenderer detail3SpriteRenderer = detail3.AddComponent<SpriteRenderer>();
                            detail3SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/MichonneHawthorne/Hair.png"); //path to hair
                            detail3SpriteRenderer.sortingLayerName = "Foreground"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Lori Grimes",
                        DescriptionOverride = "You're gonna be fine. You are going to beat this world, I know you will. You are smart, and you are strong, and you are so brave, and I love you.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/LoriGrimes/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/LoriGrimes/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("Hair");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/LoriGrimes/Hair.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Foreground"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                            GameObject detail2 = new GameObject("Сlothes on the belt");
                            detail2.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody")); //Lower Body
                            detail2.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail2.transform.localEulerAngles = Vector3.zero;
                            detail2.transform.localScale = Vector2.one;

                            SpriteRenderer detail2SpriteRenderer = detail2.AddComponent<SpriteRenderer>();
                            detail2SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/LoriGrimes/clothesbelt.png"); //path to clothes on the belt
                            detail2SpriteRenderer.sortingLayerName = "Foreground"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Carl Grimes",
                        DescriptionOverride = "I shot my mom, she was out. Hadn’t turned yet. I ended it, it was real.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/CarlGrimes/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/CarlGrimes/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Shane Walsh",
                        DescriptionOverride = "Never met a woman who knew how to turn off a light. · “If y'all wanna live, if y'all wanna survive, you gotta fight for it!",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/ShaneWalsh/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {   
                            var person = Instance.GetComponent<PersonBehaviour>();
                            
                        foreach (var limb in person.Limbs)
						{
							var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
							HumanSprites.person = person;
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/ShaneWalsh/Skin Layer.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/ShaneWalsh/Skin Layer1.png"));
						}

                    }   }
                );

                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Revolver"), //item to derive from
                        NameOverride = TWDtag + "Rick Grimes Colt Python", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "Rick Grimes revolver.", //new item description
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/RickGrimes/ThumbRevolver.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/RickGrimes/Revolver.png"); //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.FixColliders();
                        }
                    }
                );
                
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Daryl Dixon",
                        DescriptionOverride = "SORRY, BROTHER.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/DarylDixon/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/DarylDixon/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Merle Dixon",
                        DescriptionOverride = "Nobody can kill Merle except Merle.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/MerleDixon/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/MerleDixon/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Gabriel Stokes",
                        DescriptionOverride = "Anything Is Possible Until Your Heart Stops Beating.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/GabrielStokes/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/GabrielStokes/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "T-Dog (Theodore Douglas)",
                        DescriptionOverride = "Anything Is Possible Until Your Heart Stops Beating.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/TheodoreDouglas/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/TheodoreDouglas/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Aaron",
                        DescriptionOverride = "Yeah, because you know what you're doing. You're good out there, but you don't belong out there. You need to be out there sometimes risking your life.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Aaron/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {   
                            var person = Instance.GetComponent<PersonBehaviour>();
                            
                        foreach (var limb in person.Limbs)
						{
							var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
							HumanSprites.person = person;
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Aaron/Skin Layer.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Aaron/Skin Layer1.png"));
						}

                    }   }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Dwight",
                        DescriptionOverride = " I knew I'd have to face it. To pay",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Dwight/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/Dwight/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Jesus (Paul Rovia)",
                        DescriptionOverride = "No matter what they've done... They're people. There's many kinds of danger, many kinds of dying. I kill. I've killed. You do. You have.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/PaulRovia/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/PaulRovia/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("Hair");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/PaulRovia/hair.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                            GameObject detail7 = new GameObject("coat");
                            detail7.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody")); //Lower Body
                            detail7.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail7.transform.localEulerAngles = Vector3.zero;
                            detail7.transform.localScale = Vector2.one;

                            SpriteRenderer detail7SpriteRenderer = detail7.AddComponent<SpriteRenderer>();
                            detail7SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/PaulRovia/coat.png"); //path to clothes on the belt
                            detail7SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );
                                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Dale Horvath",
                        DescriptionOverride = "“The world that we knew is dead. And this new world is ugly. It's harsh. It's survival of the fittest. And that's a world I don't wanna live in.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/DaleHorvath/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/DaleHorvath/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("dale hat");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/DaleHorvath/hat.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Rosita Espinosa",
                        DescriptionOverride = "Dying is simple, it all just stops. You're dead. The people around you dying, that's the hard part.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/RositaEspinosa/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/RositaEspinosa/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("Hair Rossita");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/RositaEspinosa/Hair.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                            GameObject detail6 = new GameObject("boob1");
                            detail6.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody")); //Lower Body
                            detail6.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail6.transform.localEulerAngles = Vector3.zero;
                            detail6.transform.localScale = Vector2.one;

                            SpriteRenderer detail6SpriteRenderer = detail6.AddComponent<SpriteRenderer>();
                            detail6SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/RositaEspinosa/boob.png"); //path to clothes on the belt
                            detail6SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Andrea Harrison",
                        DescriptionOverride = "The pain doesn't go away. You just make room for it.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Andrea/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/Andrea/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("Hair Andrea");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/Andrea/Hair.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                            GameObject detail6 = new GameObject("boob1");
                            detail6.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody")); //Lower Body
                            detail6.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail6.transform.localEulerAngles = Vector3.zero;
                            detail6.transform.localScale = Vector2.one;

                            SpriteRenderer detail6SpriteRenderer = detail6.AddComponent<SpriteRenderer>();
                            detail6SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/Andrea/boob.png"); //path to clothes on the belt
                            detail6SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Madison Clark",
                        DescriptionOverride = "Sometimes a leader has to show force to gain respect.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/MadisonClark/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/MadisonClark/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("Hair Madison Clark");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/MadisonClark/hair.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                            GameObject detail6 = new GameObject("boob madison");
                            detail6.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody")); //Lower Body
                            detail6.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail6.transform.localEulerAngles = Vector3.zero;
                            detail6.transform.localScale = Vector2.one;

                            SpriteRenderer detail6SpriteRenderer = detail6.AddComponent<SpriteRenderer>();
                            detail6SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/MadisonClark/boob.png"); //path to clothes on the belt
                            detail6SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Alpha",
                        DescriptionOverride = "There are only two kinds of people left in this world, the ones brave enough to walk with the dead and everybody else.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Alpha/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/Alpha/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            
                            GameObject detail6 = new GameObject("boob2");
                            detail6.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody")); //Lower Body
                            detail6.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail6.transform.localEulerAngles = Vector3.zero;
                            detail6.transform.localScale = Vector2.one;

                            SpriteRenderer detail6SpriteRenderer = detail6.AddComponent<SpriteRenderer>();
                            detail6SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/Alpha/boob.png"); //path to clothes on the belt
                            detail6SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );


                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Hershel Greene",
                        DescriptionOverride = "You step outside, you risk your life. You take a drink of water, you risk your life. And nowadays you breathe, and you risk your life. Every moment now... you don't have a choice. The only thing you can choose is what you're risking it for. Now, I can make these people feel better and hang on a little bit longer. I can save lives. And that's enough reason to risk mine.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/HershelGreene/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/HershelGreene/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Jake Otto",
                        DescriptionOverride = "Jeremiah Otto Jr.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/JakeOtto/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/JakeOtto/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Kenny",
                        DescriptionOverride = "She left me...my son...people that cared about us...I forgive her, but it don't make it any less wrong. You don't just end it cause it's hard. You stick it out, and you help the folks you care about. So let's figure a way outta here and get that little girl.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Kenny/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/Kenny/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail1 = new GameObject("Kenny hat");
                            detail1.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail1.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail1.transform.localEulerAngles = Vector3.zero;
                            detail1.transform.localScale = Vector2.one;

                            SpriteRenderer detail1SpriteRenderer = detail1.AddComponent<SpriteRenderer>();
                            detail1SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/Kenny/hair.png"); //path to hair
                            detail1SpriteRenderer.sortingLayerName = "Decals"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Simon",
                        DescriptionOverride = "Everyone! After this is done, we get to work. Just know that I didn't want this, but the Sanctuary must stand. This is not the man to prosecute this conflict. Just wanted to say...a grateful enclave thanks you!",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Simon/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/Simon/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Tyreese Williams",
                        DescriptionOverride = "it's not over. It's not over... It's-- it's not over. I didn't turn away. I kept listening to the news so I could do what I could to help! I'm not giving up. You hear me? I'm not giving up! People like me... people like me, they can live. Ain't nobody got to die today.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/TyreeseWilliams/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/TyreeseWilliams/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Nick Clark",
                        DescriptionOverride = "I killed a man, now I'm sleeping in his house.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/NickClark/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/NickClark/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Beth Greene",
                        DescriptionOverride = "I'm not Carol. I'm not Maggie. I've survived and you don't get it 'cause I'm not like you or them. But I made it and you don't get to treat me like crap just because you're afraid.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/BethGreene/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/BethGreene/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Maggie Greene",
                        DescriptionOverride = "You killed people who had families. And you did it in front of their families.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/MaggieGreene/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/MaggieGreene/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Glenn Rhee",
                        DescriptionOverride = "People you love... they made you who you are. They're still part of you. If you stop being you, that last bit of them that's still around inside, who you are... it's gone.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/GlennRhee/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/GlennRhee/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Abraham Ford",
                        DescriptionOverride = "I mean you got the strength, you got the skill. Thing is, for you people, for what you can do, that's just surrender. Now we get Eugene to Washington and he make the dead die and the living will have this world again.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/AbrahamFord/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/AbrahamFord/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Eugene Porter",
                        DescriptionOverride = "After I save the world, I still have to live with myself. I'm not leaving them behind.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/EugenePorter/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/EugenePorter/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                            GameObject detail4 = new GameObject("Hair Eugene");
                            detail4.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail4.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail4.transform.localEulerAngles = Vector3.zero;
                            detail4.transform.localScale = Vector2.one;

                            SpriteRenderer detail3SpriteRenderer = detail4.AddComponent<SpriteRenderer>();
                            detail3SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/EugenePorter/Hair.png"); //path to hair
                            detail3SpriteRenderer.sortingLayerName = "Foreground"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Morgan Jones",
                        DescriptionOverride = "Rick is trying to build something. He needs all the hands he can get. He wants to show people that things can change. You don't wanna be alone. People. Everything is about people... everything in this life that's worth a damn",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/MorganJones/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/MorganJones/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Carol Peletier",
                        DescriptionOverride = "What happened to Henry... and how I felt after... it controlled me. I let it take me down a very dark path. People that I care about were hurt. Now everything that I do, I carry that. This is a path you don't want to go down. Now you let him go. Let him go.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/CarolPeletier/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/CarolPeletier/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Philip Blake",
                        DescriptionOverride = "In this life now, you kill or you die.",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/PhilipBlake/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/PhilipBlake/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Lee Everett",
                        DescriptionOverride = "You come back here I'll kill you. Do you hear me? I'll kill you!",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/LeeEverett/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/LeeEverett/Skin Layer.png");
                            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = TWDtag + "Clementine",
                        DescriptionOverride = "You're fine! Just look at me. You're fine!",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Clementine/Thumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("art/Skins/Clementine/Skin Layer.png");
                            var flesh = ModAPI.LoadTexture("art/Skins/Clementine/Flesh Layer.png");
                            var bone = ModAPI.LoadTexture("art/Skins/Clementine/Bone Layer.png");



                            var person = Instance.GetComponent<PersonBehaviour>();

                            GameObject detail5 = new GameObject("Hair Clementine");
                            detail5.transform.SetParent(Instance.transform.Find("Head")); //head
                            detail5.transform.localPosition = new Vector3(0.0f, 0.0f); //position relative to body part (x, y)
                            detail5.transform.localEulerAngles = Vector3.zero;
                            detail5.transform.localScale = Vector2.one;

                            SpriteRenderer detail3SpriteRenderer = detail5.AddComponent<SpriteRenderer>();
                            detail3SpriteRenderer.sprite = ModAPI.LoadSprite("art/Skins/Clementine/Hair.png"); //path to hair
                            detail3SpriteRenderer.sortingLayerName = "Foreground"; //sprite level name => this "Sorting layers" in https://www.studiominus.nl/ppg-modding/details/layers.html

                            person.SetBodyTextures(skin, flesh, bone, 1);

                                foreach (var body in person.Limbs)
                            {
                                     body.transform.root.localScale *= 0.97f;
                            }
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = TWDtag + "Clementine Hat",
                        DescriptionOverride = "Just a hat",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Clementine/capThumb.png"),
                        AfterSpawn = (Instance) =>
                        { 
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/Clementine/cap.png");
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                            armor.stabResistance = 356748f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;
                            armor.otherSprite = ("art/Skins/Clementine/cap.png");
                            Instance.FixColliders();
                        }  
                    }
                );
                
                //Zombie
			    ModAPI.Register(
				    new Modification()
				    {
				    	OriginalItem = ModAPI.FindSpawnable("Human"),
				    	NameOverride = TWDtag + "Walkers",
				    	DescriptionOverride = "Im the one who eat brains.",
				    	CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
				    	ThumbnailOverride = ModAPI.LoadSprite("art/Skins/Zombies/Thumb.png"),
				    	AfterSpawn = (Instance) =>
					    {
					    	var person = Instance.GetComponent<PersonBehaviour>();
					    	person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
					    	person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
					    	person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
					    	person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
					    	person.SetRottenColour(255, 255, 255);
					    	Instance.GetComponent<PersonBehaviour>().RandomisedSize = false;
    

						     var bite = Instance.transform.Find("Head");
							 var phys1 = bite.GetComponent<PhysicalBehaviour>();
							 var prop1 = ModAPI.FindPhysicalProperties("Human");
							 prop1.Sharp = true;
							 prop1.SharpAxes = new[]
							 {
								 new SharpAxis(Vector2.right, 0f, 0.50f, true, true),
							 };
							 phys1.Properties = prop1;

						foreach (var limb in person.Limbs)
						{
							var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
							HumanSprites.person = person;
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie1.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie2.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie3.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie4.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie5.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie6.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie7.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie8.png")); 
							HumanSprites.Textures.Add(ModAPI.LoadTexture("art/Skins/Zombies/Zombie69.png")); 
						}


						foreach (var body in person.Limbs)
						{
							body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
							body.IsZombie = true;
							body.BreakingThreshold *= 3;
						}
					    }
				    }
			    );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),
                        NameOverride = TWDtag + "Lucille",
                        DescriptionOverride = "Lucille is now thirsty....",
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/NeganSmith/Thumblucille.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/NeganSmith/Lucille.png");
                            GameObject basebal = GameObject.Instantiate(ModAPI.FindSpawnable("Baseball Bat").Prefab);
                            basebal.transform.SetParent(Instance.transform);
                            basebal.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/NeganSmith/wire.png");
                            basebal.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                            basebal.FixColliders();
                            basebal.transform.position = Instance.transform.position;
                            basebal.transform.eulerAngles = Instance.transform.eulerAngles;
                            basebal.gameObject.AddComponent<FixedJoint2D>();
                            basebal.gameObject.GetComponent<FixedJoint2D>().connectedBody = Instance.gameObject.GetComponent<Rigidbody2D>();
                            var wire = Instance.AddComponent<NoCollide>();
                            wire.NoCollideSetA = basebal.GetComponentsInChildren<Collider2D>();
                            wire.NoCollideSetB = Instance.gameObject.GetComponentsInChildren<Collider2D>();
                            var phys = basebal.gameObject.GetComponent<PhysicalBehaviour>();
                            var prop = ModAPI.FindPhysicalProperties("Wood");
                            prop.Sharp = true;
                            prop.SharpAxes = new[]
                            {
                            new SharpAxis(Vector2.right, 0f, 0.1f, true, false),
                                                        new SharpAxis(Vector2.left, 0f, 0.1f, true, false),
                                                                                    new SharpAxis(Vector2.down, 0f, 0.1f, true, false),
                                                                                                                new SharpAxis(Vector2.up, 0f, 0.1f, true, false),
                            };
                            phys.Properties = prop;
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
                        NameOverride = TWDtag + "Michonne Katana", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "The Katana is mainly used by Michonne as it is her signature weapon. The Katana is characterized by its distinctive appearance: a curved, slender, single-edged blade with a circular or squared guard and long grip to accommodate two hands. It has historically been associated with the samurai of feudal Japan, and has become renowned for its sharpness and strength.", //new item description
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/MichonneHawthorne/KatanaThumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/MichonneHawthorne/Katana.png");
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
                        NameOverride = TWDtag + "Morgan stick", //new item name with a suffix to assure it is globally unique
                        DescriptionOverride = "The Katana is mainly used by Michonne as it is her signature weapon. The Katana is characterized by its distinctive appearance: a curved, slender, single-edged blade with a circular or squared guard and long grip to accommodate two hands. It has historically been associated with the samurai of feudal Japan, and has become renowned for its sharpness and strength.", //new item description
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"), //new item category
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/MorganJones/StickThumb.png"), //new item thumbnail (relative path)
                        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                        {
                            //get the SpriteRenderer and replace its sprite with a custom one
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/MorganJones/morganstick.png");
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Crossbow"), //Starting with the Crossbow sets up a nice template with everything we need.
                        NameOverride = TWDtag + "Daryl Dixon Crossbow",
                        DescriptionOverride = "A crossbow is a weapon consisting of a bow mounted on a stock that shoots projectiles, often called bolts, quarrels or locks. The medieval crossbow was called by many names, most of which derived from the word ballista, a torsion engine resembling a crossbow in appearance.", //For more inf
                        CategoryOverride = ModAPI.FindCategory("The Walking Dead Mod"),
                        ThumbnailOverride = ModAPI.LoadSprite("art/Skins/DarylDixon/CrossbowThumb.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/DarylDixon/Crossbow.png");
                            Instance.FixColliders();
                            var pLauncher = Instance.GetComponent<ProjectileLauncherBehaviour>();

                            pLauncher.projectileAsset = ModAPI.FindSpawnable("daryldixonbolt");
                        }
                    }
                );
                ModAPI.Register(
                new Modification()
                {
                        OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"), //Starting with the Crossbow sets up a nice template with everything we need.
                        NameOverride = "daryldixonbolt",
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/Skins/DarylDixon/bolt.png");
                            Instance.FixColliders();
                        }
                    }
                );

            
                
  
        }
    }
}

public class RandomHumanTextureBehaviour : MonoBehaviour //credit to mishanya for this behaviour
	{
		public List<Texture2D> Textures = new List<Texture2D>();
		int chosenIndex = 0;
		public PersonBehaviour person;
		ContextMenuButton menuButton;
		public void Start()
		{
			chosenIndex = UnityEngine.Random.Range(0, Textures.Count - -1); 
			ChangeTexture();   
			GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("ChangeTexture", "Change Texture", "Switches to the change human skin", new UnityAction[1]
				 {
				(UnityAction) (() =>
				{
					ChangeTexture();
					foreach (var humanSkin in person.Limbs)
					{
						if (humanSkin.GetComponent<RandomHumanTextureBehaviour>())
						{
						   humanSkin.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
						}
					}

				})
				 }));     
		}
		public void ChangeTexture()
		{
			chosenIndex -= 1;
			if (chosenIndex > Textures.Count - 1)
				chosenIndex = 0;
			person.SetBodyTextures(Textures[chosenIndex]);
		}
	}
            